=== debian/changelog ===
grafana (2.6.0+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #797702).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 13 Feb 2016 10:49:01 +1100
