=== debian/control ===
Source: grafana
Section: web
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: pkg-go <pkg-go-maintainers@lists.alioth.debian.org>
Build-Depends: debhelper (>= 9), dh-golang, dh-systemd
    ,golang-github-aws-aws-sdk-go-dev (>= 1.0.0)
      ,golang-github-bradfitz-gomemcache-dev
    ,golang-toml-dev | golang-github-burntsushi-toml-dev
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-go-ldap-ldap-dev
    ,golang-github-go-sql-driver-mysql-dev
    ,golang-github-go-xorm-xorm-dev
    ,golang-github-go-xorm-core-dev
    ,golang-github-go-ini-ini-dev
  ,golang-github-go-macaron-gzip-dev
  ,golang-github-go-macaron-binding-dev
  ,golang-github-go-macaron-session-dev
    ,golang-github-gosimple-slug-dev
    ,golang-github-jmespath-go-jmespath-dev
    ,golang-github-jtolds-gls-dev
      ,golang-github-klauspost-compress-dev
      ,golang-github-klauspost-cpuid-dev
      ,golang-github-klauspost-crc32-dev
    ,golang-github-lib-pq-dev
    ,golang-github-mattn-go-sqlite3-dev
    ,golang-github-rainycape-unidecode-dev
    ,golang-github-smartystreets-goconvey-dev
    ,golang-github-streadway-amqp-dev
    ,golang-github-unknwon-com-dev
    ,golang-github-vaughan0-go-ini-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-dev
    ,golang-gopkg-asn1-ber.v1-dev
    ,golang-gopkg-bufio.v1-dev
    ,golang-gopkg-ini.v1-dev
    ,golang-gopkg-macaron.v1-dev
    ,golang-gopkg-redis.v2-dev
    ,node-typescript
Build-Depends-Indep: node-less
Standards-Version: 3.9.6
Homepage: http://grafana.org
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/grafana.git
Vcs-Git: https://anonscm.debian.org/collab-maint/grafana.git

Package: grafana
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, grafana-data (= ${source:Version})
        ,golang-go
        ,adduser
        ,libfontconfig
Built-Using: ${misc:Built-Using}
Description: feature rich metrics dashboard and graph editor
 Grafana is a feature rich metrics dashboard and graph editor for Graphite,
 InfluxDB & OpenTSDB.
 .
 This package provides Grafana daemon.

Package: grafana-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
    ,fonts-font-awesome
    ,libjs-angularjs
    ,libjs-jquery
##    ,libjs-jquery-flot
    ,libjs-twitter-bootstrap
#    ,phantomjs {removed from unstable}
Recommends: grafana
Built-Using: ${misc:Built-Using}
Description: feature rich metrics dashboard and graph editor - data files
 Grafana is a feature rich metrics dashboard and graph editor for Graphite,
 InfluxDB & OpenTSDB.
 .
 This package provide files for the web interface.

#Package: golang-github-grafana-grafana-dev
#Architecture: all
#Depends: ${misc:Depends}, ${shlibs:Depends}
#Built-Using: ${misc:Built-Using}
#Description: feature rich metrics dashboard and graph editor
# Grafana is a feature rich metrics dashboard and graph editor for Graphite,
# InfluxDB & OpenTSDB.
