=== requirements.txt ===
httpx>=0.27
mcp>=0.1.0; python_version >= "3.10"
starlette>=0.31
python-dotenv>=1.0
pytest-asyncio>=0.20
